<template>
  <div>
    <el-form
      :model="carForm"
      status-icon
      :rules="rules"
      ref="carForm"
      label-width="120px"
    >
      <el-form-item required label="Car model" prop="model">
        <el-input v-model="carForm.model"></el-input>
      </el-form-item>

      <el-form-item
        required
        label="Registration number"
        prop="registration_mark"
      >
        <el-input v-model="carForm.registration_mark"></el-input>
      </el-form-item>

      <el-form-item required label="Car type" prop="car_type_id">
        <el-select
          v-model="carForm.car_type_id"
          placeholder="Choose required car type"
        >
          <el-option label="Passenger" :value="0"></el-option>
          <el-option label="Freight" :value="1"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item required label="Purchase date" prop="purchase_date">
        <el-date-picker
          v-model="carForm.purchase_date"
          type="date"
        >
        </el-date-picker>
      </el-form-item>

      <el-form-item required label="Mileage" prop="mileage">
        <el-input v-model="carForm.mileage"></el-input>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" @click="handleSaveCar">Save</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
  import carModelMixin from "@/mixins/carModelMixin";
  import { mapActions } from "vuex";
  import { ACTIONS_SAVE_CAR } from "@/plugins/constants";

  export default {
    mixins: [carModelMixin],
    methods: {
      ...mapActions({ ACTIONS_SAVE_CAR }),
      async handleSaveCar() {
        await this.$refs["carForm"].validate();

        this.ACTIONS_SAVE_CAR(this.carForm)
          .then(({data}) => {
            this.$router.push({ name: "Car", params: { id: data.insertId }, });
            this.$notify.success({ message: "Successfully added car" });
          })
          .catch(({ response }) => {
            this.$notify.error({ message: response.data });
          });
      },
    },
  };
</script>

<style>
  .error {
    color: tomato;
  }

  .el-input {
    margin: 3px;
    padding: 5px;
  }
</style>